function setCookie(name, value) {
    /**
     * Create a cookie for ten years?
     */
    var today = new Date();
    var expires = new Date();

    expires.setTime(today.getTime() + (10*365*24*60*60*1000));
    document.cookie = name + "=" + value + ";expires=" + expires.toGMTString();
}
//encodeURIComponent(value)

function getCookie(name) {
    /**
     * Retrieve the value of a cookie due to it's name.
     */
    var regex = new RegExp("(?:; )?" + name + "=([^;]*);?");

    if (regex.test(document.cookie))
        return (RegExp["$1"]);
    else
        return null;
}
//return decodeURIComponent(RegExp["$1"]);

function tab_to_str(tab) {
    /**
     * Transform 2D tab to string separate by semicolon.
     * Ex : [[42, 'test', 5], [56, 'salut', 3]] =>
     * "42, test, 5|56, salut, 3"
     */
    var result = "";
    var inter = [];
    for (var i = 0; tab[i]; i++)
        inter.push(tab[i]);
    result = inter.join('|');
    console.log(result)
    return (result);
}

function str_to_tab(str) {
    /**
     * Transform string to 2D tab.
     * Ex : "42, test, 5|56, salut, 3" =>
     * [[42, 'test', 5], [56, 'salut', 3]]
     */
    var result = [];
    var split = str.split('|');
    for (var i = 0; split[i]; i++)
        result.push(split[i].split(','));
    return (result);
}

function save_session() {
    /**
     * Save old_labels_tab and unselect_tab in Cookies.
     */
    setCookie("old_labels_tab", tab_to_str(hierarchy.old_labels_tab));
    setCookie("unselect_labels_tab", tab_to_str(hierarchy.unselect_tab));
    setCookie("language", hierarchy.labels_language);
}

function setup_session() {
    hierarchy.old_labels_tab = str_to_tab(getCookie('old_labels_tab'));
    hierarchy.unselect_tab = str_to_tab(getCookie('unselect_labels_tab'));
    hierarchy.labels_language = result.labels_language = getCookie('language');
    hierarchy.init_all_labels();
    result.maj_results(3);
    hierarchy.maj_new_labels_tab();
}
