function create_tab_of_labels(tab_id_labels, all_labels) {
    /**
     * Thanks to an array of id_labels, select row in all_labels
     * that have the same id and copy this row [id, name, father_id]
     * in result.
     */
    var result = [];
    var index = -1;
    var in_old_labels_tab = -1;
    for (var i = 0; tab_id_labels[i]; i++) {
        in_old_labels_tab = is_in_tab(tab_id_labels[i], hierarchy.old_labels_tab, 0, 2);
        if (in_old_labels_tab == -1) {
            index = is_in_tab(tab_id_labels[i], all_labels, 0, 2);
            if (index != -1)
                result.push(all_labels[index]);
        }
    }
    return (result);
}

function get_diff_between_labels(labels_tab) {
    /**
     * Put in 'final_tab' all labels that do not appear
     * in each tutorial.
     */
    var final_tab = [];
    var nb_tutos = result.result_tab.length;
    var nb_occu = 0;
    for (var i = 0; labels_tab[i]; i++) {
        nb_occu = calc_nb_occu_in_array(labels_tab[i], labels_tab);
        if (nb_occu != nb_tutos && is_in_tab(labels_tab[i], final_tab, null, 1) == -1) {
            final_tab.push(labels_tab[i]);
        }
    }
    return (final_tab);
}

function remove_labels_language(labels_tab, id_labels_lang, line) {
    /**
     * deletes labels that correspond to a language.
     * if line == 1 => [id_label, name, father_id] is return
     * else jsute the ID of the label is return.
     */
    var new_tab = [];
    var a = 0;
    for (var i = 0; labels_tab[i]; i++) {
        for (var j = 0; id_labels_lang[j]; j++) {
            if (labels_tab[i][0] == id_labels_lang[j])
                a++;
        }
        if (a == 0)
            (line == 1) ? new_tab.push(labels_tab[i]) : new_tab.push(labels_tab[i][0]);
        a = 0;
    }
    return (new_tab);
}

function join_labels_from_old_tab(old_tab) {
    /**
     * Take all id of labels from old_tab and join them.
     * Used for sql requests.
     * ex : '12,34,15,...'
     */
    var result = '';
    for (var i = 0; old_tab[i]; i++) {
        if (i != 0)
            result += ',';
        result += old_tab[i][0];
    }
    return (result);
}

function get_id_label(label_name) {
    var posi = is_in_tab(label_name, hierarchy.all_labels, 1, 2);
    if (posi != -1)
        return (hierarchy.all_labels[posi][0]);
    else
        return (-1);
}