/**
 * These functions allow to update the list of tutotials
 * to print based on the labels contain in hierarcy.old_labels_tab.
 */

function del_unselect_language() {
	/**
	 * Due to link of tutos, check if each tuto correspond at the language
	 * selected. If not, the tuto is not selected for result_tab.
	 */
	var posi = -2;
	var result_final = [];

	if (result.results_language[0] % 2 == 0 && result.results_language[1] % 2 == 0)
		return;
	for (var i = 0; result.result_tab[i]; i++) {
		if (result.results_language[0] % 2 == 0)
			posi = is_in_tab(result.result_tab[i][0], result.results_fr, 0, 1);
		if (posi >= 0)
			result_final.push(result.result_tab[i]);
		posi = -2;
		if (result.results_language[1] % 2 == 0)
			posi = is_in_tab(result.result_tab[i][0], result.results_us, 0, 1);
		if (posi >= 0)
			result_final.push(result.result_tab[i]);
		posi = -2;
	}
	result.result_tab = result_final;
}

// function maj_results_from_db() {
// 	/**
//	 *                 [NOT USED]
// 	 * Selects links related to labels in 'childs_of_old_labels'
// 	 * and labels in old tab and fill 'result_tab' with tutorials
// 	 * related to this links.
// 	 */
// 	var all_links = [];
// 	var join_labels = '';
// 	result.result_tab = [];
// 	if (result.childs_of_old_labels.length != 0)
// 		join_labels = result.childs_of_old_labels.join(',');
// 	else
// 		join_labels = join_labels_from_old_tab(hierarchy.old_labels_tab);
// 	join_labels = add_father_to_child_tab(hierarchy.old_labels_tab, join_labels);
// 	all_links = JSON.parse(request_ajax("labels_links/"+join_labels));
// 	result.links_of_results = "'"+all_links.join("','")+"'";
// 	result.result_tab = JSON.parse(request_ajax_post('tutos', result.links_of_results));
// 	del_unselect_language();
// 	result.del_unselected_results();
// 	hierarchy.maj_new_labels_tab();
// }

function maj_tutos_after_unselect() {
	/**
	 * Selects links related to labels in 'childs_of_old_labels'
	 * and labels in old tab and fill 'result_tab' with tutorials
	 * related to this links.
	 */
	var all_id_labels = [];
	var join_labels = '';
	result.result_tab = [];

	var unselect_label_childs = get_all_childs_of_father(hierarchy.all_labels, hierarchy.unselect_tab[0][0])
	if (unselect_label_childs.length == 0)
		join_labels = hierarchy.unselect_tab[0][0];
	else
		join_labels = unselect_label_childs.join(',')+','+hierarchy.unselect_tab[0][0];
	all_id_labels = JSON.parse(request_ajax("labels_links_unselect/"+join_labels));
	result.links_of_results = all_id_labels.join(', ');
	result.result_tab = JSON.parse(request_ajax("tutos/"+result.links_of_results));
	del_unselect_language();
	result.del_unselected_results();
	hierarchy.maj_new_labels_tab();
}

function maj_results_after_remove() {
	/**
	 * Select tutos from database but each tuto
	 * returned must have all selected labels. For example, AFTER
	 * REMOVE one label they stay : "Calcul, CPP". The tutos
	 * selected must have this two labels.
	 */
	join_labels = join_labels_from_old_tab(hierarchy.old_labels_tab);
	all_id_labels = JSON.parse(request_ajax("tuto_family/"+join_labels));
	result.links_of_results = all_id_labels.join(', ');
	result.result_tab = JSON.parse(request_ajax("tutos/"+result.links_of_results));
	del_unselect_language();
	result.del_unselected_results();
	hierarchy.maj_new_labels_tab();
}

function maj_results_for_many_labels() {
	/**
	 * If there is several labels (after left click on one label from hierachy)
	 * in old_tab we select just the last and we keep
	 * just the tutos in result_tab affiliate to this label.
	 * This happens when a [new label is added] to precedents
	 */
	var final_tab = [];
	var last_label = hierarchy.old_labels_tab[hierarchy.old_labels_tab.length - 1][0];
	var tuto_links_last_label = JSON.parse(request_ajax("link/"+last_label));
	
	for (var i = 0; result.result_tab[i]; i++) {
		if (is_in_tab(result.result_tab[i][0], tuto_links_last_label, null, 1) != -1)
			final_tab.push(result.result_tab[i]);
	}
	result.result_tab = final_tab;
	del_unselect_language();
	result.del_unselected_results();
	hierarchy.maj_new_labels_tab();
}