
# Image for development

Those commands are meant to be launched within the `docker` directory. Each time a significant change is made to the `Dockerfile.dev`, please increase the version number in `image_dev.txt`.

* build_dev.sh : build a local image.
* run_dev.sh : run the local image, mounting `..` as `/work`.
* push_dev.sh : once image is stable, push it to `gitlab.in2p3.fr`.

The "dev" flavor of all files is meant to produce an image which
includes all the needed external packages, but not the LabelsTower application itself,
which should be mounted when creatin the container, so that any file modification
is directly reflected in the browser, on the default flask port 5000.


# Image for deployment

The "prod" flavor of all files is meant to produce an image which includes all the needed files,
and served on the default port 80. 



